unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, rmDGraph, ExtCtrls, rmAGraph, ToolWin, Menus, ImgList, IniFiles,
  ActnList, TeeProcs, TeEngine, Chart, StdCtrls;

type
  TPortToUse = (apNone, apLPT1, apLPT2, apCOM1, apCOM2, apCOM3, apCOM4, apJOY1);
  TInput = record
    // InputType: String[1];  // A(nalog) or D(igital)
    // common for A and D inputs
    Caption: string[255];
    Enabled: boolean;
    ActiveAlarm: boolean;
    DelayBeforeAlarm: integer;
    CountBeforeAlarm: byte;
    ErrorCode: byte;
    // only for A inputs
    ActualValue: real;
    MinLimit: double;
    MaxLimit: double;
    // only for D inputs
    ActualState: boolean;
    NominalStateIsON: boolean;
  end;
  TGroup = record
    caption: string[255];
    Active: boolean;
  end;
  TfmMain = class(TForm)
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Ouvrir1: TMenuItem;
    Sauver1: TMenuItem;
    Sauversous1: TMenuItem;
    N1: TMenuItem;
    Quitter1: TMenuItem;
    Configurationdesentres1: TMenuItem;
    Aide1: TMenuItem;
    Indexdelaide1: TMenuItem;
    N2: TMenuItem;
    Apropos1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ActionList1: TActionList;
    ActConfigOpen: TAction;
    ImageList1: TImageList;
    Nouveau1: TMenuItem;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ActConfigNew: TAction;
    ActConfigSave: TAction;
    ActConfigSaveAs: TAction;
    ActClose: TAction;
    ActDataOpen: TAction;
    Ouvrirfichierdedonnes1: TMenuItem;
    N3: TMenuItem;
    ActConfigEdit: TAction;
    ToolButton9: TToolButton;
    ActShowFormAbout: TAction;
    ActConfigInputCopyToClipboard: TAction;
    ActConfigInputPasteFromClipboard: TAction;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet7: TTabSheet;
    TabSheet9: TTabSheet;
    rmDGraph1: TrmDGraph;
    rmAGraph1: TrmAGraph;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    Acquisition1: TMenuItem;
    mnuUse64D: TMenuItem;
    mnuUse64D64A: TMenuItem;
    mnuUse4D: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    ActCaptureStart: TAction;
    ActCaptureStop: TAction;
    Dmarreracquisition1: TMenuItem;
    Arrteracquisition1: TMenuItem;
    ProgressBar1: TProgressBar;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ActDataSave: TAction;
    ActDataSaveAs: TAction;
    ActDataSave1: TMenuItem;
    ActDataSaveAs1: TMenuItem;
    ActDataPrint: TAction;
    Imprimergraphique1: TMenuItem;
    N6: TMenuItem;
    mnuUseSimulation: TMenuItem;
    lblHardwareInterfaceNotDetected: TLabel;
    lblError: TLabel;
    Shape1: TShape;
    mnuUseLPT1: TMenuItem;
    mnuUseLPT2: TMenuItem;
    N7: TMenuItem;
    UtiliserleportsrieCOM11: TMenuItem;
    UtiliserleportsrieCOM21: TMenuItem;
    UtiliserleportsrieCOM31: TMenuItem;
    UtiliserleportsrieCOM41: TMenuItem;
    UtiliserleportJoystick1: TMenuItem;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure ActShowFormAboutExecute(Sender: TObject);
    procedure ActConfigEditExecute(Sender: TObject);
    procedure ActConfigOpenExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActConfigSaveExecute(Sender: TObject);
    procedure ActConfigSaveAsExecute(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure mnuUse64DClick(Sender: TObject);
    procedure ActCaptureStartExecute(Sender: TObject);
    procedure ActCaptureStopExecute(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure mnuUseLPT1Click(Sender: TObject);
  private
    { Dclarations prives }
    procedure SetMainAppTitle(sFile: string);
    procedure OpenConfigFile(sFile: string);
    function  AskForSave: integer;
    procedure SaveConfigFile(sFile: string);
    procedure InitInputs;
    procedure SetGUICtrlState;
    procedure SetScaleLabels(pIdx: integer);
    procedure SetAnalogScaleLabels(BaseIdx: integer);
    procedure SetDigitalScaleLabels(BaseIdx: integer);
    procedure RunCapture;
    procedure Graph_AddPointsSimulation;
    function CheckForHardwareInterface64D: boolean;
    function CheckForHardwareInterface64D64A: boolean;
    procedure Graph_AddPoints4D;
    procedure Graph_AddPoints64D;
    procedure Graph_AddPoints64D64A;
  public
    { Dclarations publiques }
    function  ErrorCodeToStr(code: byte): string;
  end;

const
  CRLF = #13#10;
  FirstAnalogBlockIdx = 0;
  FirstDigitalBlockIdx = 4;

var
  fmMain: TfmMain;
  AppPath: string;
  AppIniFileName: string;
  OpenedConfigFileName: string;
  ActualConfigModified: boolean;
  Groups: array[0..7] of TGroup;    // 0..3 Analog, 4..7 Digital, 16 inputs / group
  Inputs: array[0..127] of TInput;  // 0..63 Analog, 64..127 Digital
  ActivePortToUse: TPortToUse;
  ClipBrdInput: TInput;
  CaptureInProgress: boolean;
  StopRequest: boolean;
  HardwareInterfaceDetected: boolean;

implementation

uses
  DataModules, ResStr, rmForms, rmMisc,
  InputConfig, DataRead, About;

{$R *.DFM}

procedure TfmMain.FormCreate(Sender: TObject);
begin
  HardwareInterfaceDetected := false;
  AppPath := extractFilePath(application.exeName);
  AppIniFileName := changeFileExt(application.exeName, '.ini');
  OpenedConfigFileName := '';
  ActualConfigModified := false;
  InitInputs;
  PageControl1.ActivePageIndex := 4;
  PageControl1Change(nil);
  mnuUseLPT1Click(mnuUseLPT1);
  SetGUICtrlState;
end;

procedure TfmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if CaptureInProgress then begin
    CanClose := false;
    exit;
  end;
  if ActualConfigModified then
    CanClose := (AskForSave <> mrCancel)
  else
    CanClose := true;
end;

procedure TfmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  rmForms.SaveFormsSizeAndPos(AppIniFileName);
end;

procedure TfmMain.SetGUICtrlState;
begin
  PageControl1.enabled := not CaptureInProgress;
  ActConfigNew.Enabled := not CaptureInProgress;
  ActConfigOpen.Enabled := not CaptureInProgress;
  ActConfigSave.Enabled := not CaptureInProgress;
  ActConfigSaveAs.Enabled := not CaptureInProgress;
  ActDataOpen.Enabled := not CaptureInProgress;
  ActDataSave.Enabled := not CaptureInProgress;
  ActDataSaveAs.Enabled := not CaptureInProgress;
  ActClose.Enabled := not CaptureInProgress;
  ActConfigEdit.Enabled := not CaptureInProgress;
  ActShowFormAbout.Enabled := not CaptureInProgress;
  ActConfigInputCopyToClipboard.Enabled := not CaptureInProgress;
  ActConfigInputPasteFromClipboard.Enabled := not CaptureInProgress;
  ActCaptureStart.Enabled := not CaptureInProgress;
  ActCaptureStop.Enabled := CaptureInProgress;
  ActDataPrint.Enabled := not CaptureInProgress;
  if CaptureInProgress then
    Shape1.Brush.color := clLime
  else
    Shape1.Brush.color := clGreen;
end;

procedure TfmMain.InitInputs;
var
  i: integer;
begin
  for i := 0 to 7 do begin    // groups
    Case i of
      0..3 : Groups[i].Caption := format('Groupe_A%d', [i + 1]);
      4..7 : Groups[i].Caption := format('Groupe_D%d', [i - 3]);
    end;
  end;
  for i := 0 to 127 do begin   // inputs
    Case i of
      000..063 : Inputs[i].Caption := format('Entre_A%d', [i + 1]);
      064..127 : Inputs[i].Caption := format('Entre_D%d', [i - 63]);
    end;
    Inputs[i].Enabled := true;
  end;
end;

procedure TfmMain.SetMainAppTitle(sFile: string);
begin
  caption := format('%s - %s', [sMainAppTitle, extractFileName(sFile)]);
end;

procedure TfmMain.OpenConfigFile(sFile: string);
var
  ini: TIniFile;
  i: integer;
  section: string;
begin
  ini := TIniFile.Create(sFile);
  ProgressBar1.Visible := true;
  application.ProcessMessages;
  try
    screen.Cursor := crHourGlass;

    // load groups configuration
    for i := 0 to 15 do begin    // groups
      Case i of
        00..07 : Section := 'AGrp_' + StrFixLength(intToStr(i), 'Left', '0', 2);
        08..15 : Section := 'DGrp_' + StrFixLength(intToStr(i - 8), 'Left', '0', 2);
      end;
      groups[i].caption := ini.ReadString(section, 'Caption', Section);
    end;

    // load inputs configuration
    ProgressBar1.Max := 127;
    ProgressBar1.Position := 0;
    for i := 0 to 127 do begin
      ProgressBar1.Position := i;
      Case i of
        000..063 : Section := 'AIn_' + StrFixLength(intToStr(i), 'Left', '0', 3);
        064..127 : Section := 'DIn_' + StrFixLength(intToStr(i - 64), 'Left', '0', 3);
      end;
      Inputs[i].Caption := ini.ReadString(section, 'Caption', Section);
      Inputs[i].Enabled := ini.ReadBool(section, 'Enabled', true);
      Inputs[i].DelayBeforeAlarm := ini.ReadInteger(section, 'DelayBeforeAlarm', 0);
      Inputs[i].CountBeforeAlarm := ini.ReadInteger(section, 'CountBeforeAlarm', 0);
      Inputs[i].ErrorCode := 0;    // always reset to 0
      Inputs[i].ActualValue := 0;  // always reset to 0
      Inputs[i].ActiveAlarm := ini.ReadBool(section, 'ActiveAlarm', true);
      Inputs[i].MinLimit := ini.ReadFloat(section, 'MinLimit', 0);
      Inputs[i].MaxLimit := ini.ReadFloat(section, 'MaxLimit', 0);
      Inputs[i].ActualState := ini.ReadBool(section, 'ActualState', true);
      Inputs[i].NominalStateIsOn := ini.ReadBool(section, 'NominalStateIsOn', true);
    end;

  finally
    screen.Cursor := crDefault;
    ini.Free;
    ProgressBar1.Visible := false;
  end;

  // file variable and main title refresh
  OpenedConfigFileName := sFile;
  SetMainAppTitle(OpenedConfigFileName);
  ActualConfigModified := false;
  PageControl1Change(nil);

end;

procedure TfmMain.SaveConfigFile(sFile: string);
var
  ini: TIniFile;
  i: integer;
  section: string;
begin
  ini := TIniFile.Create(sFile);
  try
    screen.Cursor := crHourGlass;

    // save groups configuration
    for i := 0 to 15 do begin    // groups
      Case i of
        00..07 : Section := 'AGrp_' + StrFixLength(intToStr(i), 'Left', '0', 2);
        08..15 : Section := 'DGrp_' + StrFixLength(intToStr(i - 8), 'Left', '0', 2);
      end;
      ini.WriteString(section, 'Caption', groups[i].Caption);
    end;

    // save inputs configuration
    for i := 0 to 127 do begin
      Case i of
        000..063 : Section := 'AIn_' + StrFixLength(intToStr(i), 'Left', '0', 3);
        064..127 : Section := 'DIn_' + StrFixLength(intToStr(i - 64), 'Left', '0', 3);
      end;
      ini.WriteString(section, 'Caption', Inputs[i].Caption);
      ini.WriteBool(section, 'Enabled', Inputs[i].Enabled);
      ini.WriteInteger(section, 'DelayBeforeAlarm', Inputs[i].DelayBeforeAlarm);
      ini.WriteInteger(section, 'CountBeforeAlarm', Inputs[i].CountBeforeAlarm);
      // ini.WriteBool(section, 'ErrorCode', Inputs[i].ErrorCode);
      // ini.WriteString(section, 'ActualValue', realToStr(5, Inputs[i].ActualValue));
      ini.WriteBool(section, 'ActiveAlarm', Inputs[i].ActiveAlarm);
      ini.WriteFloat(section, 'MinLimit', Inputs[i].MinLimit);
      ini.WriteFloat(section, 'MaxLimit', Inputs[i].MaxLimit);
      // ini.WriteString(section, 'ActualState', realToStr(5, InpInputs[i]ut.ActualState));
      ini.WriteBool(section, 'NominalStateIsOn', Inputs[i].NominalStateIsOn);
    end;

  finally
    screen.Cursor := crDefault;
    ini.Free;
  end;

  // file variable and main title refresh
  OpenedConfigFileName := sFile;
  SetMainAppTitle(OpenedConfigFileName);
  ActualConfigModified := false;
end;

function TfmMain.AskForSave: integer;
var
  sMsg: string;
  ret: integer;
begin
  sMsg := 'Des modifications ont eu lieu depuis la dernire sauvegarde.' + CRLF +
          'Voulez-vous sauvegarder ces modifications ?';
  ret := messageDlg(sMsg, mtConfirmation, mbYesNoCancel, 0);
  case ret of
    mrCancel : result := mrCancel;
    mrYes : begin
      ActConfigSaveExecute(nil);
      result := mrYes;
    end;
    mrNo : result := mrNo;
    else result := mrCancel;
  end;
end;

function TfmMain.ErrorCodeToStr(code: byte): string;
begin
  case code of
    000 : result := sErrorCode_000; // no error
    001 : result := sErrorCode_001; // actually in fault
    002 : result := sErrorCode_002; // memorised fault
    else result := '';
  end;
end;

procedure TfmMain.ActShowFormAboutExecute(Sender: TObject);
var
  frm: TfmAbout;
begin
  frm := TfmAbout.create(self);
  try
    frm.showModal;
  finally
    frm.free;
  end;
end;

procedure TfmMain.ActConfigEditExecute(Sender: TObject);
var
  frm: TfmInputConfig;
begin
  frm := TfmInputConfig.create(self);
  fmMain.WindowState := wsMinimized;
  try
    rmForms.LoadFormSizeAndPos(AppIniFileName, frm);
    frm.rmCommutator1Change(nil);
    frm.showModal;
    rmForms.SaveFormSizeAndPos(AppIniFileName, frm);
  finally
    frm.free;
    fmMain.WindowState := wsNormal;
  end;
  PageControl1Change(nil);
end;

procedure TfmMain.ActConfigOpenExecute(Sender: TObject);
begin
  with OpenDialog1 do begin
    if execute then
      OpenConfigFile(fileName);
  end;
end;

procedure TfmMain.ActConfigSaveExecute(Sender: TObject);
begin
  if fileExists(OpenedConfigFileName) then
    SaveConfigFile(OpenedConfigFileName)
  else
    ActConfigSaveAsExecute(nil);
end;

procedure TfmMain.ActConfigSaveAsExecute(Sender: TObject);
begin
  with SaveDialog1 do begin
    if execute then
      SaveConfigFile(fileName);
  end;
end;

procedure TfmMain.PageControl1Change(Sender: TObject);
begin
  rmAGraph1.Visible := PageControl1.ActivePageIndex in [0..3];
  rmDGraph1.Visible := PageControl1.ActivePageIndex in [4..7];
  SetScaleLabels(PageControl1.ActivePageIndex);
end;

procedure TfmMain.SetScaleLabels(pIdx: integer);
var
  BaseIdx: integer;
begin
  case PIdx of
    0 : begin BaseIdx := 0; SetAnalogScaleLabels(BaseIdx); end;
    1 : begin BaseIdx := 8; SetAnalogScaleLabels(BaseIdx); end;
    2 : begin BaseIdx := 16; SetAnalogScaleLabels(BaseIdx); end;
    3 : begin BaseIdx := 24; SetAnalogScaleLabels(BaseIdx); end;
    4 : begin BaseIdx := 64; SetDigitalScaleLabels(BaseIdx); end;
    5 : begin BaseIdx := 80; SetDigitalScaleLabels(BaseIdx); end;
    6 : begin BaseIdx := 96; SetDigitalScaleLabels(BaseIdx); end;
    7 : begin BaseIdx := 112; SetDigitalScaleLabels(BaseIdx); end;
  end;
end;

procedure TfmMain.SetAnalogScaleLabels(BaseIdx: integer);
begin
  // do nothing at the moment
end;

procedure TfmMain.SetDigitalScaleLabels(BaseIdx: integer);
var
  sLabels: string;
  i, StartIdx, EndIdx: integer;
begin
  sLabels := '';
  StartIdx := BaseIdx;
  EndIdx := StartIdx + 15;
  for i := StartIdx to EndIdx do
    if i <> EndIdx then
      sLabels := sLabels + Inputs[i].Caption + ';'
    else
      sLabels := sLabels + Inputs[i].Caption;
  rmDGraph1.TraceLabels := sLabels;
end;

procedure TfmMain.mnuUse64DClick(Sender: TObject);
var
  iTag: integer;
begin
  HardwareInterfaceDetected := true;
  (sender as TmenuItem).checked := true;
  iTag := (sender as TmenuItem).tag;
  case iTag of
    0 : ;  // do nothing, simulation
    1 : ;  // do nothing, no specific hardwar interface (direct use of LPT)
    2 : HardwareInterfaceDetected := CheckForHardwareInterface64D;
    3 : HardwareInterfaceDetected := CheckForHardwareInterface64D64A;
  end;
  lblHardwareInterfaceNotDetected.visible := not HardwareInterfaceDetected;
end;

function TfmMain.CheckForHardwareInterface64D: boolean;
begin
  result := false;
end;

function TfmMain.CheckForHardwareInterface64D64A: boolean;
begin
  result := false;
end;

procedure TfmMain.ActCaptureStartExecute(Sender: TObject);
begin
  lblError.Visible := false;
  StopRequest := false;
  CaptureInProgress := true;
  SetGUICtrlState;
  RunCapture;
end;

procedure TfmMain.ActCaptureStopExecute(Sender: TObject);
begin
  StopRequest := true;
  CaptureInProgress := false;
  SetGUICtrlState;
end;

procedure TfmMain.Graph_AddPointsSimulation;
var
  i: integer;
  b: boolean;
  s: string;
begin
  s := '';
  for i := 0 to 15 do
  begin
    b := boolean(random(2));
    s := s + boolToStr(b, '1', '0');
  end;
  rmDGraph1.AddValues(s, true);
end;

procedure TfmMain.Graph_AddPoints4D;
var
  i, BlockIdx, InputIdx: integer;
  b: boolean;
  s: string;
begin
  // always read at First Digital Block
  BlockIdx := FirstDigitalBlockIdx;
  Data_ReadBlock(BlockIdx);
  s := '';
  for i := 0 to 3 do
  begin
    InputIdx := (BlockIdx * 4) + i;
    b := inputs[InputIdx].ActualState;
    s := s + boolToStr(b, '1', '0');
  end;
  rmDGraph1.AddValues(s, true);
end;

procedure TfmMain.Graph_AddPoints64D;
begin

end;

procedure TfmMain.Graph_AddPoints64D64A;
begin

end;

procedure TfmMain.RunCapture;
begin
  //mnuUse64DClick(mnuUse4D);
  repeat
    application.ProcessMessages;

    // simulation
    if mnuUseSimulation.Checked then
      Graph_AddPointsSimulation

    // direct reading from LPT connector
    else if mnuUse4D.Checked then
      Graph_AddPoints4D

    // read from digital demux hardware interface
    else if mnuUse64D.Checked then
      Graph_AddPoints64D

    // read from digital/analog demux hardware interface
    else if mnuUse64D64A.Checked then
      Graph_AddPoints64D64A;

    delay(100, true);

    if Shape1.Brush.color <> clLime then
      Shape1.Brush.color := clLime
    else
      Shape1.Brush.color := clGreen;


  until StopRequest;
end;


procedure TfmMain.FormResize(Sender: TObject);
begin
  with rmDGraph1 do
    MaxItems := Width - LeftMargin - RightMargin;
end;

procedure TfmMain.mnuUseLPT1Click(Sender: TObject);
var
  idx: integer;
begin
  idx := (sender as TmenuItem).tag;
  case idx of
    1 : ActivePortToUse := apLPT1;
    2 : ActivePortToUse := apLPT2;
    3 : ActivePortToUse := apCOM1;
    4 : ActivePortToUse := apCOM2;
    5 : ActivePortToUse := apCOM3;
    6 : ActivePortToUse := apCOM4;
    7 : ActivePortToUse := apJOY1;
  else ActivePortToUse := apNone;
  end;
  Port_SetBaseAdress(idx);
end;

end.
